"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Consequence(ProtocolElement):
    """
    Object to hold consequence types linked to appropriate transcript.
    Modified from org.opencb.biodata.models.variant.avro 2.9.3-GEL
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "sequenceOntologyTerms",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "exonOverlap": reports_7_0_0.ExonOverlap,
            "sequenceOntologyTerms": reports_7_0_0.SequenceOntologyTerm,
            "spliceScores": reports_7_0_0.SpliceScores,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import reports as reports_7_0_0

        return {
            "org.gel.models.report.avro.ExonOverlap": reports_7_0_0.ExonOverlap,
            "org.gel.models.report.avro.SequenceOntologyTerm": reports_7_0_0.SequenceOntologyTerm,
            "org.gel.models.report.avro.SpliceScores": reports_7_0_0.SpliceScores,
            "org.gel.models.report.avro.Consequence": reports_7_0_0.Consequence,
        }

    __slots__ = [
        "sequenceOntologyTerms",
        "biotype",
        "cdnaChanges",
        "cdnaPosition",
        "cdsLength",
        "cdsPosition",
        "codon",
        "ensemblGeneId",
        "ensemblProteinId",
        "ensemblTranscriptId",
        "exonOverlap",
        "geneName",
        "genomicChanges",
        "proteinChanges",
        "spliceScores",
        "strand",
        "transcriptFlags",
    ]

    def __init__(
        self,
        sequenceOntologyTerms,
        biotype=None,
        cdnaChanges=None,
        cdnaPosition=None,
        cdsLength=None,
        cdsPosition=None,
        codon=None,
        ensemblGeneId=None,
        ensemblProteinId=None,
        ensemblTranscriptId=None,
        exonOverlap=None,
        geneName=None,
        genomicChanges=None,
        proteinChanges=None,
        spliceScores=None,
        strand=None,
        transcriptFlags=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_7_0_0.Consequence model.

        :param sequenceOntologyTerms:
        :type sequenceOntologyTerms: list[SequenceOntologyTerm]
        :param biotype:
        :type biotype: None | str
        :param cdnaChanges:
            cDNA change, HGVS nomenclature (e.g.: c.76A>T)
        :type cdnaChanges: None | list[str]
        :param cdnaPosition:
        :type cdnaPosition: None | int
        :param cdsLength:
        :type cdsLength: None | int
        :param cdsPosition:
        :type cdsPosition: None | int
        :param codon:
        :type codon: None | str
        :param ensemblGeneId:
        :type ensemblGeneId: None | str
        :param ensemblProteinId:
        :type ensemblProteinId: None | str
        :param ensemblTranscriptId:
        :type ensemblTranscriptId: None | str
        :param exonOverlap:
        :type exonOverlap: None | list[ExonOverlap]
        :param geneName:
        :type geneName: None | str
        :param genomicChanges:
            gDNA change, HGVS nomenclature (e.g.: g.476A>T)
        :type genomicChanges: None | list[str]
        :param proteinChanges:
            Protein change, HGVS nomenclature (e.g.: p.Lys76Asn)
        :type proteinChanges: None | list[str]
        :param spliceScores:
        :type spliceScores: None | list[SpliceScores]
        :param strand:
        :type strand: None | str
        :param transcriptFlags:
        :type transcriptFlags: None | list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "7.0.0"
